︠25bd27db-e5f8-4388-9987-20360796eb6cs︠
def get_all_minors(matrix):
    k,n=matrix.dimensions();
    subsets=(Combinations(range(n),k));
    minors=[];
    for cols in subsets:
        minors.append(matrix.matrix_from_columns(cols).determinant());
    return minors;

def is_tnn(matrix):
    minors=get_all_minors(matrix);
    non_zero_minor=0;
    for minor in minors:
        if (abs(minor)>0.000001):
            non_zero_minor=minor;
            break;
    for minor in minors:
        minor/=non_zero_minor;
        if (minor<-0.00000001):
            return false;
        if (abs(minor.imag())>0.0000001):
            print("IMAGINARY MINOR: "+str(minor));
    return true;

def get_top_submatrix(matrix,k):
    evecs=matrix.eigenvectors_right();
    n=matrix.ncols();
    evecs=sorted(evecs,key=lambda tup: tup[0].real(),reverse=1);
    #print([evec[0] for evec in evecs]);
    MM=Matrix(CC,k,n);
    for i in range(k):
        for j in range(n):
            #print(evecs[i]);
            MM[i,j]=evecs[i][1][0][j];
    return MM;

def get_tridiag_matrix(a,b,c):
    n=len(c);
    M=Matrix(n,n);
    for i in range(n):
        M[i,i]=c[i];
        if (i<n-1):
            M[i,i+1]=a[i];
            M[i+1,i]=b[i];
    if (len(a)==n):
        M[n-1,0]=a[n-1];
    if (len(b)==n):
        M[0,n-1]=b[n-1];
    return M;

#c=[23,1,8,13,1]
#a=[75,1,7,8,7];
#b=[2,3,4,1,19];

n=5;
iter=50;
set_random_seed(3);
max_value=20;
for it in range(iter):
    a=[ZZ.random_element(max_value)+1 for i in range(n)];
    b=[ZZ.random_element(max_value)+1 for i in range(n)];
    c=[ZZ.random_element(max_value)+1 for i in range(n)];
    M=get_tridiag_matrix(a,b,c);

    print(M);
    print("checking tnn for each k")
    for k in range(1,n+1):
        M[n-1,0]=(-1)^(k-1)*abs(M[n-1,0]);
        M[0,n-1]=(-1)^(k-1)*abs(M[0,n-1]);
        MM=get_top_submatrix(M,k);
        #print("submatrix computed; checking tnn...")
        TNN="is tnn!"
        if (not is_tnn(MM)):
            TNN="NOT TNN!:("
        #print(MM);
        #print("-------------------"+TNN+"-----------------")
        print("k="+str(k)+": "+TNN)
        if (TNN!="is tnn!"):
            print("FAIL")
            exit();
︡e89e3c69-c1e3-4287-ac9d-4c5bb4e12a2b︡{"stdout":"[ 4  5  0  0 16]\n[ 6 14  2  0  0]\n[ 0 15  3  3  0]\n[ 0  0  9  2 11]\n[ 3  0  0  3 16]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[15  3  0  0  2]\n[ 3  3 18  0  0]\n[ 0 14  3 14  0]\n[ 0  0  7 10  8]\n[10  0  0  4  5]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[15  5  0  0  5]\n[ 4  7 12  0  0]\n[ 0 18  1 16  0]\n[ 0  0 18 13  7]\n[ 5  0  0  3  8]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[18 10  0  0  4]\n[ 5 19 10  0  0]\n[ 0 10  9 10  0]\n[ 0  0 19 11 10]\n[14  0  0  8  6]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[19  2  0  0 11]\n[14 17  8  0  0]\n[ 0  6  6 10  0]\n[ 0  0 20 18  2]\n[ 7  0  0 20 10]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[ 6 12  0  0  9]\n[ 7 20 20  0  0]\n[ 0  2 17 11  0]\n[ 0  0  2 11 18]\n[ 9  0  0  3 14]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[20 14  0  0  2]\n[ 7  3 10  0  0]\n[ 0  7  7 15  0]\n[ 0  0 14  8 10]\n[11  0  0 12  5]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[10  6  0  0  4]\n[ 6 18  5  0  0]\n[ 0  3 13  7  0]\n[ 0  0 20  5 19]\n[ 4  0  0  9  1]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[17  4  0  0 17]\n[ 6  9 11  0  0]\n[ 0 12 18  9  0]\n[ 0  0  7 15  5]\n[ 1  0  0 17 16]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[16  3  0  0  2]\n[ 6  6 13  0  0]\n[ 0 14  3  4  0]\n[ 0  0  4 11 13]\n[ 2  0  0  6  7]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[10 20  0  0  4]\n[13  1 19  0  0]\n[ 0 19 13  3  0]\n[ 0  0 17 12  8]\n[ 5  0  0 10  6]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 3 13  0  0  6]\n[ 5 13  4  0  0]\n[ 0  1  1 20  0]\n[ 0  0  1 20  9]\n[15  0  0  7  6]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[16  6  0  0 19]\n[15 10 11  0  0]\n[ 0 13 19 11  0]\n[ 0  0 12  2 17]\n[ 1  0  0  6  3]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[ 7  2  0  0 18]\n[ 1 15 11  0  0]\n[ 0 10 11  6  0]\n[ 0  0  8  5 18]\n[ 2  0  0  4  5]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 4 15  0  0  6]\n[ 5 10 10  0  0]\n[ 0  7  6 15  0]\n[ 0  0 20 12  2]\n[20  0  0 13 18]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[ 3  4  0  0 13]\n[20 19 20  0  0]\n[ 0 14  9  7  0]\n[ 0  0 13  9  3]\n[ 6  0  0 13  3]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[18  7  0  0 18]\n[14 11  4  0  0]\n[ 0 16  8 15  0]\n[ 0  0  7  4 16]\n[16  0  0 12 18]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[ 7  6  0  0  5]\n[ 6 11 13  0  0]\n[ 0 16  3  1  0]\n[ 0  0 14  3  4]\n[14  0  0 11  9]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[11 20  0  0 13]\n[11 20 14  0  0]\n[ 0 20 20 13  0]\n[ 0  0  8 13 12]\n[ 1  0  0 11  2]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[14 19  0  0 20]\n[19 18  4  0  0]\n[ 0 14  2  1  0]\n[ 0  0  6 16 15]\n[ 5  0  0  7 20]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 7 10  0  0 19]\n[ 4  8  1  0  0]\n[ 0 10 20  4  0]\n[ 0  0 13  2  9]\n[10  0  0  5  2]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 2 16  0  0 20]\n[14  9  5  0  0]\n[ 0 12 13  2  0]\n[ 0  0 12 15  3]\n[ 8  0  0 19  6]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[18 20  0  0 15]\n[16  1 18  0  0]\n[ 0  4  6  6  0]\n[ 0  0  4  6  6]\n[17  0  0  8 13]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[ 1  1  0  0  9]\n[ 2 15 16  0  0]\n[ 0  3  7 15  0]\n[ 0  0  5 16  6]\n[12  0  0  3 18]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[10 14  0  0 10]\n[19  8 15  0  0]\n[ 0 15  4  2  0]\n[ 0  0  8 19 19]\n[19  0  0 17 13]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[12 10  0  0 15]\n[14  3  5  0  0]\n[ 0 12  7 19  0]\n[ 0  0  9 12 17]\n[19  0  0  7 19]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 9 12  0  0 15]\n[10 13  4  0  0]\n[ 0  7 16 17  0]\n[ 0  0 14  1  8]\n[ 6  0  0  6  8]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[15  8  0  0  5]\n[15 17  7  0  0]\n[ 0 17  7 12  0]\n[ 0  0  5 19 20]\n[ 2  0  0  3  8]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 7 11  0  0 15]\n[19  3 19  0  0]\n[ 0 17 15 16  0]\n[ 0  0  8 18 13]\n[ 3  0  0  6 20]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[17 13  0  0  8]\n[ 7  8  2  0  0]\n[ 0  9  1  1  0]\n[ 0  0  7 20  4]\n[16  0  0  5  7]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[11 14  0  0  8]\n[10 14 15  0  0]\n[ 0  6  4 16  0]\n[ 0  0 16 16  4]\n[ 2  0  0 18  7]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 3  8  0  0  1]\n[16  3 10  0  0]\n[ 0  5 19 20  0]\n[ 0  0 14  7  7]\n[13  0  0 17  3]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[ 3  3  0  0  8]\n[16  1  7  0  0]\n[ 0  2 12 18  0]\n[ 0  0  3 11 20]\n[15  0  0  4  7]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[ 5 20  0  0  4]\n[ 2 15  6  0  0]\n[ 0 11 13  5  0]\n[ 0  0 15  9  5]\n[ 2  0  0 13 10]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 4  8  0  0 13]\n[ 1 19  5  0  0]\n[ 0  9  6 14  0]\n[ 0  0 19 14  7]\n[ 1  0  0 10 20]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[ 1  2  0  0 13]\n[ 9  5  4  0  0]\n[ 0 15 16 18  0]\n[ 0  0  6  3  7]\n[ 7  0  0  1 13]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 9 14  0  0 19]\n[ 2 13  3  0  0]\n[ 0  6  7 12  0]\n[ 0  0 13 20 13]\n[ 7  0  0  5  6]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[14  4  0  0 17]\n[20 16  7  0  0]\n[ 0 20 17  5  0]\n[ 0  0 17  6  4]\n[10  0  0  7 12]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[14 19  0  0 18]\n[16  7  5  0  0]\n[ 0 14  5  2  0]\n[ 0  0 15 11 17]\n[17  0  0  6  7]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[17  1  0  0  6]\n[ 3 11 12  0  0]\n[ 0 13 13 20  0]\n[ 0  0 17 17 15]\n[ 4  0  0 18  4]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[12 13  0  0  2]\n[ 1  8  3  0  0]\n[ 0 13 12  1  0]\n[ 0  0  5 17 12]\n[ 4  0  0  5  7]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[18  1  0  0  4]\n[15 20  9  0  0]\n[ 0  2 11 13  0]\n[ 0  0 14  5 16]\n[ 6  0  0  3 18]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[20 14  0  0 12]\n[19  9 15  0  0]\n[ 0 14 14 12  0]\n[ 0  0 10  2 20]\n[17  0  0  8 20]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[ 7 14  0  0 15]\n[ 7  8 11  0  0]\n[ 0  5  5 17  0]\n[ 0  0  5  7  5]\n[ 9  0  0 16  5]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!"}︡{"stdout":"\n[14  1  0  0 10]\n[13  9 13  0  0]\n[ 0 13  3 15  0]\n[ 0  0 12 10  6]\n[ 8  0  0  5  6]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 8  4  0  0  3]\n[20 11  5  0  0]\n[ 0 13  4 15  0]\n[ 0  0  9  8 18]\n[ 8  0  0  6 17]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[ 1 12  0  0 14]\n[ 8 17 15  0  0]\n[ 0 17 15 19  0]\n[ 0  0  9 13 17]\n[ 7  0  0  4 13]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n[ 6  9  0  0  5]\n[11 13 11  0  0]\n[ 0 16  6  8  0]\n[ 0  0  1  8  4]\n[11  0  0  7 17]\nchecking tnn for each k\nk=1: is tnn!\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[20  1  0  0 12]\n[17  3 13  0  0]\n[ 0 18 13 20  0]\n[ 0  0  4  2  5]\n[ 5  0  0  9  8]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!"}︡{"stdout":"\nk=3: is tnn!\nk=4: is tnn!"}︡{"stdout":"\nk=5: is tnn!\n[ 2  9  0  0 16]\n[15  3  8  0  0]\n[ 0  1 11  2  0]\n[ 0  0  8  4  3]\n[10  0  0 16  5]\nchecking tnn for each k\nk=1: is tnn!"}︡{"stdout":"\nk=2: is tnn!\nk=3: is tnn!"}︡{"stdout":"\nk=4: is tnn!\nk=5: is tnn!"}︡{"stdout":"\n"}︡{"done":true}︡
︠b7c2669f-7410-4896-854c-d18074295a4f︠









